unit Global; {Fractal Landscapes 3.0 - Copyright  1987..1996, Jon Shemitz}

interface

uses WinTypes;

type
  Int16 = {$ifdef Ver80} integer {$else} SmallInt {$endif} ;

const
  MaxPlys             = 8;
  MaxEdgeLength       = 1 shl (MaxPlys - 1);
  UnitLength: LongInt = 5000;
  ShadesOfGray        = 64;

type
  TCoordinate = -30000..30000;
  TTriple = record
            X,              { Width:  0 (left) to UnitLength (right)       }
            Y,              { Depth:  0 (front) to VanishingPoint.Y (back) }
            Z: TCoordinate; { Height: 0 (bottom) to UnitLength (top)       }
            end;

function Triple(X, Y, Z: TCoordinate): TTriple;

type
  TPixel = TPoint;

type
  GridCoordinate = 0..MaxEdgeLength; { Triangular grid space }
  TVertex = record
            AB, BC, CA: GridCoordinate;
            end;

function Vertex(AB, BC, CA: GridCoordinate): TVertex;

type
  DrawModes  = (dmOutline, dmFill, dmRender);
  DrawRates  = (drLow, drMedium, drHigh);

const
  Envelope = 3000;
  SeaLevel: word = 100;		{ 0 (bottom) to UnitLength (top) }
  VanishingPoint: TTriple = ( X:  1500 ;
                              Y: 25000 ; { Apparent depth of vanishing point }
                              Z: 15000 );
  LightSource: TTriple = ( X:  2500;
                           Y: +7500;
                           Z:  25000 );
  DrawMode: DrawModes   = dmOutline;
  DrawRate: DrawRates   = drHigh;

const
  Uninitialized = -30000;

var
  A, B, C: TVertex;
  Plys:       1..MaxPlys;
  EdgeLength: Int16;

  DisplayHeight,
  DisplayWidth: Int16;

implementation

function Triple(X, Y, Z: TCoordinate): TTriple;
begin
  Result.X := X;
  Result.Y := Y;
  Result.Z := Z;
end;

function Vertex(AB, BC, CA: GridCoordinate): TVertex;
begin
  Result.AB := AB;
  Result.BC := BC;
  Result.CA := CA;
end;

end.



